%% priklad 9
clear;

%% parametry signalu
A = 1.0;
To = 5.0;
fo = 1/To;

%% volba fsa: spektralne neomezeny signal, cim vetsi, tim lepsi 
% stale potrebuji dodrze, ze fsa je clely nasobek fo
fsa = 10*fo; % MENIT nasobky fsa
%fsa = 50*fo; % 
%fsa = 100*fo; % 
Tsa = 1/fsa;

No = To/Tsa; %musi vyjit cele cislo

%% signal -- na intervalu jedne periody
cast = (0:No-1)*Tsa;
signal = A*sin(2*pi/To*cast);
for i = 0:No-1,
  if signal(i+1) < 0 signal(i+1) = 0; end;
end;

figure(1);clf;
plot([cast-To,cast,cast+To], [signal, signal,signal], 'b-x');
xlabel('t');
ylabel('s(t)');

%% analyticky tvar spektra
nmax = 30;
nn = -nmax:nmax;
cnAnl = A/2/pi.*(1+(-1).^nn)./(1-nn.^2);
cnAnl( find(nn==-1) ) = 1j*A/4;
cnAnl( find(nn==1) ) = -1j*A/4;

%% vypocet spektra: 
%cn = Tsa/To*fft(signal); %stejne jako nasledujici
cn = 1/No*fft(signal);

%% zobrazeni spektra
figure(2);clf;
stem(0:No-1, abs(cn));
xlabel('n');
ylabel('|c_n|');

%% zobrazeni spektra -- fftshift()
figure(3);clf;
stem(nn, abs(cnAnl),'r-x');
hold on;
stem((0:No-1)-fix(No/2),fftshift(abs(cn)));
xlabel('n');
ylabel('|c_n|');
