%% priklad 11
clear;

%% parametry signalu
A = 1.0;
T1 = 5.0;

%% volba fsa: spektralne neomezeny signal, cim vetsi, tim lepsi
Tsa = T1/5.5;  % nemusi byt cele cislo...
%Tsa = T1/50.0;  % 
%Tsa = T1/100.0;  % 
fsa = 1/Tsa;

tmax = 30.0;
N = fix(2*tmax/Tsa);
cast=( (0:N-1)-fix(N/2) )*Tsa;

%% vytvoreni signalu
signal = zeros(1,N);
for i = 1:N,
  if (cast(i) > -T1/2 && cast(i)<=T1/2)
     signal(i) = A*(1+cos(2*pi*cast(i)/T1));
  end;
end;

figure(1);clf;
plot(cast, signal, 'b-x');
xlabel('t');
ylabel('s(t)');


%% analyticky tvar spektra
ommax = 10;
omega = linspace(-ommax,ommax,200);
SpekAnl = 2*A./omega.*(sin(T1*omega/2))./(1-(T1*omega/2/pi).^2);

%% vypocet spektra: 
SpekDFT = Tsa*fft(signal);
NDFT = length(SpekDFT);

%% zobrazeni spektra
figure(2);clf;
plot(0:NDFT-1, abs(SpekDFT), 'b-o');
xlabel('\omega');
ylabel('|S(\omega)|');


%% zobrazeni spektra -- fftshift()
figure(3);clf;
plot(omega, abs(SpekAnl),'r-x');
hold on;
plot(((0:NDFT-1)-fix(NDFT/2))*(2*pi*fsa)/NDFT, fftshift(abs(SpekDFT)),'b-o');
xlabel('\omega');
ylabel('|S(\omega)|');
