clear;

%% nacte pasmovy signal se sume -- sn_BP
load('sn_BP.mat');

fsa = 55e3;
    Tsa = 1/fsa;
% symbolova rychlost, doba trvani symbolu
fs = 1e3;
    Ts = 1/fs;
% kmitocet nosne: stred pasma pasmoveho signalu
fo = 10e3;
% vykon pasmoveho signalu bez sumu (vykon komplexni obalky je 2*P)
P = 1;
% pomer vykon sigbalu ku spektralni vykonove hustote (v [dB-Hz])
P_No_dB = 53;
% No -- PSD soufazove nebo kvadraturni slozky
No = P / (10^(P_No_dB/10));



N = length(sn_BP);

%% navrh Hilbertova transformatoru
oHilb = 30; 
bHilb = firpm(oHilb, [0.1 0.9], [1 1], 'hilbert');

figure(2);clf;
freqz(bHilb, 1);
title('Hilbret transf. -- frequency response');


figure(3);clf;
subplot(211);grid on;
stem( (0: 40-1), impz(bHilb,1,40) );
title('Hilbret transf. -- impulse response');
subplot(212);
grpdelay(bHilb,1);
title('Hilbret transf. -- group delay');


%% analyticky signal
% POZOR, sn_BP je potraba zpozdit o pocet vzorku, ktery odpovoida skupinovemu
% zpozdeni Hilberert. transf.;
% Lze realizovat FIR s impulzovou odezvou h[n] = delta[n-grpdelay] nebo 
% napr. pomoci f-ce circshift()
% a) FIR
sig_A = filter([zeros(1, oHilb/2), 1],1, sn_BP) + 1j*filter(bHilb, 1, sn_BP);
% b) circshift()
%sig_A = circshift(sn_BP,[0,oHilb/2]) + 1j*filter(bHilb, 1, sn_BP);

%% komplexni obalka
sig_CE = sig_A.*exp(-1j*2*pi*fo*(0:N-1)*Tsa);


figure(4);clf;
[PP, ww] = pwelch(sig_A,5*fix(Ts/Tsa),[],[],fsa,'twosided');
plot(ww - ww(fix(length(ww)/2)+1), 10*log10( fftshift(PP) ) ); 
grid on;
xlabel('f [Hz]');
title('PSD of analyticak signal [dB/Hz]');
%set(gca,'YLim',[-70,-20]);
set(gca,'XLim',[-fsa/2,fsa/2]);
grid on; hold on;
plot(ww - ww(fix(length(ww)/2)+1), ones(length(PP),1)*10*log10(2*No),'r-');
xlabel('f [Hz]');
legend('signal PSD', 'AWGN PSD: 2*No');


%% dalsi filtr -- potlaceni sirokopasmoveho sumu
%b1 = firpm(30, [0 2.0*fs 3.0*fs fsa/2]*2/fsa, [1 1 0 0]);
%sig_CE = filter(b1,1,sig_CE);


%% zobrazeni
figure(5);clf;
subplot(311);
plot( (0:N-1)*Tsa, real(sig_CE), 'b');
hold on;
plot( (0:N-1)*Tsa, imag(sig_CE), 'g');
legend('In-phase','Quadrature');
title('final CE');

subplot(312);
plot(real(sig_CE), imag(sig_CE), 'x:' );
axis([-2.5,2.5,-2.5,2.5]);
xlabel('I(t)'); ylabel('Q(t)');
title('final CE in complex plain');

subplot(313);
[PP, ww] = pwelch(sig_CE,5*fix(Ts/Tsa),[],[],fsa,'twosided');
plot(ww - ww(fix(length(ww)/2)+1), 10*log10( fftshift(PP) ) ); 
grid on;
xlabel('f [Hz]');
title('PSD of final CE [dB/Hz]');
set(gca,'YLim',[-70,-20]);
set(gca,'XLim',[-fsa/2,fsa/2]);
grid on; hold on;
plot(ww - ww(fix(length(ww)/2)+1), ones(length(PP),1)*10*log10(2*No),'r-');
xlabel('f [Hz]');
legend('signal PSD', 'AWGN PSD: 2*No');




