% Exercise 1 - mixtures of signal and noise

% Sinusoid (clean)

A=1 ;
f=500 ;    
fs=8000 ;
tmax=0.1 ;

tt=0:1/fs:tmax ;
s1=A*sin(2*pi*f*tt) ;

figure(31)
subplot(211)
plot(tt,s1)
xlabel('t')
ylabel('s1');
title(['Sinusoid : f=' num2str(f) 'Hz, fs=' num2str(fs) 'Hz'])


% Sinusoid with noise

vargn=0.4;
b1=sqrt(vargn)*randn(1,length(s1)) ;
subplot(212)
plot(tt,b1)
xlabel('t')
ylabel('b1');
title(['Gaussian noise with variance ' num2str(vargn)])


x=s1+b1;
Pb1=mean(b1.*b1);
Ps1=mean(s1.*s1);


SNR=10*log10(Ps1/Pb1)

figure(32)
subplot(211)
plot(tt,x)
xlabel('t')
ylabel('x=s1+b1');
title(['Sinusoid with generated noise: SNR = ' num2str(SNR) 'dB'])

SNR=-10;   %  Use also other values of target SNR = 20, 6, 0, -10

% creation of the mixture

k=sqrt(Ps1/Pb1*10^(-SNR/10));
x1=s1+k*b1 ;

subplot(212)
plot(tt,x1)
xlabel('t')
ylabel('x1=s1+K*b1');
title(['Sinusoid with scaled noise: SNR = ' num2str(SNR) 'dB'])
