% B2M31CZS - Exercise 2

A=1;
f=15;
fs=200;
tmax=1;

tt=0:1/fs:1-1/fs ;
s1=A*sin(2*pi*f*tt);

figure(1)
plot(tt,s1);
title('Sinusoid')


figure(2)

kk=-length(s1)+1:length(s1)-1;

subplot(221)
plot(kk,xcorr(s1,'biased')) ;
xlabel('k')
ylabel('R[k]');
title('Sinusoid - Biased')
subplot(222)
plot(kk,xcorr(s1,'unbiased')) ;
xlabel('k')
ylabel('R[k]');
title('Sinusoid - Unbiased')
subplot(223)
plot(kk,xcorr(s1,'coeff')) ;
xlabel('k')
ylabel('R[k]');
title('Sinusoid - Coeff')
subplot(224)
plot(kk,xcorr(s1,'none')) ;
xlabel('k')
ylabel('R[k]');
title('Sinusoid - None')


% ACF estimation for Gaussain white noise

fs=200;
tmax=1;   % try also for tmax = 10  (b2)
b1=sqrt(0.7)*randn(1,fs*tmax);

figure(3)
plot(b1);


figure(4)

kk=-length(b1)+1:length(b1)-1;

subplot(221)
plot(kk,xcorr(b1,'biased')) ;
xlabel('k')
ylabel('R[k]');
title('Gauss. white noise - Biased')
subplot(222)
plot(kk,xcorr(b1,'unbiased')) ;
xlabel('k')
ylabel('R[k]');
title('Gauss. white noise - Unbiased')
subplot(223)
plot(kk,xcorr(b1,'coeff')) ;
xlabel('k')
ylabel('R[k]');
title('Gauss. white noise - Coeff')
subplot(224)
plot(kk,xcorr(b1,'none')) ;
xlabel('k')
ylabel('R[k]');
title('Gauss. white noise - None')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Dale jiz sleduji jen principialne odlisne odhady
%   tj. vychyleny a nevychyleny
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure(5)

mean_val=0.8;

subplot(211)
sig=b1+mean_val;
plot(sig)
title('Gauss.white noise (GWN) + DC')
subplot(223)
[Rsig_biased,lags]=xcorr(sig,'biased');
plot(lags,Rsig_biased) ;
xlabel('k')
ylabel('R[k]');
title('GWN + DC - Biased')
subplot(224)
[Rsig_unbiased,lags]=xcorr(sig,'unbiased');
plot(lags,Rsig_unbiased) ;
xlabel('k')
ylabel('R[k]');
title('GWN + DC - Unbiased')

figure(6)

subplot(211)
sig=s1+mean_val;
plot(sig)
title('sinusoid + DC')
subplot(223)
[Rsig_biased,lags]=xcorr(sig,'biased');
plot(lags,Rsig_biased) ;
xlabel('k')
ylabel('R[k]');
title('sinusoid + DC - Biased')
subplot(224)
[Rsig_unbiased,lags]=xcorr(sig,'unbiased');
plot(lags,Rsig_unbiased) ;
xlabel('k')
ylabel('R[k]');
title('sinusoid + DC - Unbiased')

figure(7)

subplot(211)

Ps1=mean(s1.*s1);
Pb1=mean(b1.*b1);
SNR=10 ;           % try also for SNR = 10, 6,  3, 0, -10, -20
k=sqrt(Ps1/Pb1*10^(-SNR/10));     
sig=s1+k*b1;
plot(sig)
title(['sinusoid + GWN (Gauss. white noise) - SNR=' num2str(SNR) 'dB'])
subplot(223)
[Rsig_biased,lags]=xcorr(sig,'biased');
plot(lags,Rsig_biased) ;
xlabel('k')
ylabel('R[k]');
title('sinusoid + GWN - Biased')
subplot(224)
[Rsig_unbiased,lags]=xcorr(sig,'unbiased');
plot(lags,Rsig_unbiased) ;
xlabel('k')
ylabel('R[k]');
title('sinusoid + GWN - Unbiased')
