% B2M31CZS - Exercise 2 - ACF - detection of periodicity

if exist('/etc/init.d'),
    % For linux
    addpath /home/pollak/www/html/vyu/b2m31czs/m
    addpath /home/pollak/www/html/vyu/b2m31czs/signaly
else
    % For windows
    if exist('H:\VYUKA\CZS')
        addpath H:\VYUKA\CZS\m; 
        addpath H:\VYUKA\CZS\signaly; 
    else
        addpath C:\usr\pollak\www\html\vyu\b2m31czs\m
        addpath C:\usr\pollak\www\html\vyu\b2m31czs\signaly
    end
end



%% musical instrument tone pitch
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% [sig,fs]=audioread('cembalo_d_dur_2.wav');   instrument='cembalo';
% [sig,fs]=audioread('fletna_d_dur_6.wav');    instrument='flaute';
[sig,fs]=audioread('housle_d_dur_5.wav');      instrument='violin';
% [sig,fs]=audioread('piano_d_dur_4.wav');     instrument='piano';
% [sig,fs]=audioread('varhany1_d_dur_3.wav');    instrument='organ 1';
% [sig,fs]=audioread('varhany2_d_dur_8.wav');    instrument='organ 2';

figure(21)
subplot(211)
plot(sig)
title(['Signal - ' instrument])

tlen=0.01 ;
wlen=floor(fs*tlen);
starttime=20000;
sigf=sig(starttime+1:starttime+wlen);

subplot(223)
plot(sigf)
title('short-time frame')
subplot(224)
kk=-length(sigf)+1:length(sigf)-1 ;
plot(kk,xcorr(sigf,'biased'));
title('ACF')

% Quitar 
[sig,fs]=audioread('kytara_d_dur_1.wav');

figure(22)
subplot(211)
plot(sig)
title('Signal - GUITAR')

subplot(212)
tlen=0.01 ;
wlen=floor(fs*tlen);
starttime=20000;
sigf=sig(starttime+1:starttime+wlen);
plot(sigf)
title('Selected short-time frame')

figure(23)

subplot(221)
plot(sigf)
title('s-t frame')
subplot(222)
kk=-length(sigf)+1:length(sigf)-1 ;
plot(kk,xcorr(sigf,'biased'));
title('ACF - effect of non-zero mean')

sigf=sigf-mean(sigf);

subplot(223)
plot(sigf)
title('centered s-t frame')
subplot(224)
kk=-length(sigf)+1:length(sigf)-1 ;
plot(kk,xcorr(sigf,'biased'));
title('ACF - from centered signal')



%% Speech pitch
%%%%%%%%%%%%%%


% Try also for other voices: vm0, vf0, vm1, vf1, vm2, vf2, ...., vm9, vf9
sp1=loadbin('vm3.bin');
sp2=loadbin('vf3.bin');

fs=16000;

wlen=512;

figure(24) ;
subplot(221)
plot(sp1)
title('signal - male voice')
sp1frame=sp1(1:wlen);
subplot(222)
plot(sp1frame);
title('frame - male voice')

subplot(223)
plot(sp2)
title('signal - male voice')
sp2frame=sp2(1:wlen);
subplot(224)
plot(sp2frame);
title('frame - female voice')


figure(25)
kk=-length(sp1frame)+1:length(sp1frame)-1 ;
subplot(211)
plot(kk,xcorr(sp1frame,'biased'));
title('ACF - male voice')
subplot(212)
kk=-length(sp2frame)+1:length(sp2frame)-1 ;
plot(kk,xcorr(sp2frame,'biased'));
title('ACF - female voice')





