hel% B2M31CZS - Discrete systems of higher orders
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% System No. 1 : y[n] = x[n] + 2 x[n-1] + 1.5 y[n-1] - y[n-2] 

b1=[1 2];
a1=[1 -1.5 1];

figure(1)
freqz(b1,a1,1000)
title('System No.1 : y[n] = x[n] + 2 x[n-1] + 1.5 y[n-1] - y[n-2]')

figure(2)
zplane(b1,a1)
title('System No.1 : y[n] = x[n] + 2 x[n-1] + 1.5 y[n-1] - y[n-2]')

figure(3)
impz(b1,a1,20)
title('System No.1 : y[n] = x[n] + 2 x[n-1] + 1.5 y[n-1] - y[n-2]')

% System No. 2 : y[n] = 0.4455 x[n-1] + 1.2728 y[n-1] - 0.81 y[n-2] 

b2=[0 0.4455];
a2=[1 -1.2728 0.81];

figure(4)
freqz(b2,a2,1000)
title('System No.2 : y[n] = 0.4455 x[n-1] + 1.2728 y[n-1] - 0.81 y[n-2]')

figure(5)
zplane(b2, a2)
title('System No.2 : y[n] = 0.4455 x[n-1] + 1.2728 y[n-1] - 0.81 y[n-2]')

figure(6)
impz(b2, a2, 100 )
title('System No.2 : y[n] = 0.4455 x[n-1] + 1.2728 y[n-1] - 0.81 y[n-2]')

% System No. 3 : y[n] = x[n]  + 0.81 x[n-2]


b3=[1 0 81];
a3=[1];

figure(7)
freqz(b3,a3,1000)
title('System No.3 : y[n] = x[n] + 0.81 x[n-2]')

figure(8)
zplane(b3, a3)
title('System No.3 : y[n] = x[n] + 0.81 x[n-2]')

figure(9)
impz(b3, a3, 20 )
title('System No.3 : y[n] = x[n] + 0.81 x[n-2]')

% System No. 4 : "all=pole" filter with two complex-conjugate poles p_1 = 0.9 *exp ( +/- j * pi/4 ) 

b4=1;
a4=poly([0.9*exp(j*pi/4) 0.9*exp(-j*pi/4)]);

figure(10)
freqz(b4,a4,1000)
title('System No.4 : all=pole, p_1|2 = 0.9 *exp ( +/- j * pi/4 )')

figure(11)
zplane(b4, a4)
title('System No.4 : all=pole, p_1|2 = 0.9 *exp ( +/- j * pi/4 )')

figure(12)
impz(b4, a4, 20 )
title('System No.4 : all=pole, p_1|2 = 0.9 *exp ( +/- j * pi/4 )')


% System No. 5 : FIR vs. inverse IIR, various magnitude of zeros|poles 

b_2=0.49 ;   % Try for b_2=0.81 , 0.64, 0.925

% FIR
b5=[1 0 b_2];
a5=1;
% IIR
a5=[1 0 b_2];
b5=1;

figure(13)
freqz(b5,a5,1000)
title('System No.5 : FIR vs. IIR, various magnitude of zeros|poles')

figure(14)
zplane(b5, a5)
title('System No.5 : FIR vs. IIR, various magnitude of zeros|pole')

figure(15)
impz(b5, a5, 20 )
title('System No.5 : FIR vs. IIR, various magnitude of zeros|pole')


% System No. 6 : y[n] = 1.5 x[n] + 0.5 x[n-1] -0.1 y[n-1] + 0.72 y[n-2]

b6=[1 1.5] ;
a6=[1 0.1 0.72];

figure(16)
freqz(b6,a6,1000)
title('System No.6 : y[n] = 1.5 x[n] + 0.5 x[n-1] -0.1 y[n-1] + 0.72 y[n-2]')

figure(17)
zplane(b6,a6)
title('System No.6 : y[n] = 1.5 x[n] + 0.5 x[n-1] -0.1 y[n-1] + 0.72 y[n-2]')

figure(18)
impz(b6, a6, 20 )
title('System No.6 : y[n] = 1.5 x[n] + 0.5 x[n-1] -0.1 y[n-1] + 0.72 y[n-2]')


% System No. 7,8 : MA filter of varying order

M=3;  % Try also M = 9 and other values

b7=1/(M+1)*ones(1,M+1) ;
a7=1;

figure(19)
freqz(b7,a7,1000)
title(['MA filter of varying order:  M = ' num2str(M)])

figure(20)
zplane(b7,a7)
title(['MA filter of varying order:  M = ' num2str(M)])

figure(21)
impz(b7, a7, 20 )
title(['MA filter of varying order:  M = ' num2str(M)])


% System No. 9,10 : Comb filter of varying order

M=9;  % Try also M = 9 and other values

b7=1 ; b7(M+1)=1 ;
a7=1;

figure(22)
freqz(b7,a7,1000)
title(['Comb filter of varying order:  M = ' num2str(M)])

figure(23)
zplane(b7,a7)
title(['Comb filter of varying order:  M = ' num2str(M)])

figure(24)
impz(b7, a7, 20 )
title(['Comb filter of varying order:  M = ' num2str(M)])



