% BF - Kvadraturne zrcadlove filtry

N=100;
b0 = fir1(N,0.5) ;
H0=freqz(b0,1,1000) ;
H0abs=20*log10(abs(H0));

b1 = fir1(N,0.5,'high');
% b1 = b0.*((-1).^(0:N));
H1=freqz(b1,1,1000) ;
H1abs=20*log10(abs(H1));

figure(103); 
plot(abs(H0).^2+abs(H1).^2)

figure(10)
subplot(211)
stem(b0);
title('Impulse response of H_1(z)')
subplot(212)
stem(b1)
title('Impulse response of H_2(z)')


bg0 = fliplr(b0);
ag0 = [zeros(1,N-1) 1] ;
G0=freqz(bg0,ag0,1000);
G0abs=20*log10(abs(G0));

bg1 = fliplr(b1);
ag1 = [zeros(1,N-1) 1] ;
G1=freqz(bg1,ag1,1000);
G1abs=20*log10(abs(G1));

figure(1)
plot(H0abs,'b');
grid
hold on
plot(H1abs,'r');
plot(G0abs,'g--');
plot(G1abs,'k--');
hold off

figure(2)
plot(unwrap(angle(H0)),'b');
grid
hold on
plot(unwrap(angle(H1)),'r');
plot(unwrap(angle(G0)),'g--');
plot(unwrap(angle(G1)),'k--');
hold off

s=loadbin('SA000CB1.CS0');

s0=filter(b0,1,s);
s1=filter(b1,1,s);

figure(3);
subplot(211)
plot(s0);
subplot(212)
plot(s1);

figure(4);
subplot(211)
spectrogram(s0,512,'yaxis');
subplot(212)
spectrogram(s1,512,'yaxis');


% y0=filter(bg0,ag0,s0);
% y1=filter(bg1,ag1,s1);
y0=filter(bg0,1,s0);
y1=filter(bg1,1,s1);
% y0=filter(b0,1,s0);
% y1=filter(b1,1,s1);


figure(5);
subplot(211)
plot(y0);
subplot(212)
plot(y1);

figure(6);
subplot(211)
spectrogram(y0,512,'yaxis');
subplot(212)
spectrogram(y1,512,'yaxis');

y=y0+y1;

figure(7)
plot(s,'b')
hold on
plot(y,'g')
plot(y(N+1:end),'r');
hold off
xlim([20840 20870])



