% Nacteni/generovani signalu

% Generovani sinusovky
f=100;
fs=8000;
tmax=0.4 ;
% sig=sin(2*pi*f*(0:1/fs:tmax)) ;

% Nacteni cisteho recoveho signalu
% sig=loadbin('vm0.bin');  fs=16000 ;
% sig=loadbin('SA110992.CS0');  fs=16000 ;
% sig=loadbin('ma034014.ils');  fs=16000 ;

% Nacteni recoveho signalu se sumem
% sig=loadbin('SA110992_auto1.CS0');  fs=16000 ;
% sig=loadbin('SA107S06_auto2.CS0');  fs=16000 ;
sig=loadbin('ma034014_auto3.ils');  fs=16000 ;


% Vypocet poctu oken
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sig=sig(:);
slen=length(sig);

wlen=512 ;
wstep=wlen/2 ;
wnum=(slen-wlen)/wstep+1 ;

w=hamming(wlen);
% w=rectwin(wlen);
% w=hanning(wlen);
% w=blackman(wlen);

% Vykresleni vstupniho signalu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure(1); clf ;
subplot(211);
plot(sig);
title('Vstupni signal');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Vytvoreni masky pamove propusti
%   fc1 = 300 Hz
%   fc2 = 3400 Hz

fc1 = 300 ;
fc2 = 3400 ;

kc1=round(fc1/fs*wlen) ;
kc2=round(fc2/fs*wlen) ;

H = [zeros(kc1,1); ones(kc2-kc1,1); zeros(wlen-2*kc2+1,1); ones(kc2-kc1,1); zeros(kc1-1,1)] ;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Nalezeni odhadu amplitudoveho spektra sumu
%   z prvniho casti signalu bez reci
%   (prvnich 30 segmentu)
winit =30 ;
Nabs=[] ;
for i=1:winit,
  ii=(i-1)*wstep+1;
  jj=(i-1)*wstep+wlen;
  frame=sig(ii:jj).*w;
  X=fft(frame);
  Xabs = abs(X) ;
  Nabs = [Nabs Xabs] ;
end;
Navg=mean(Nabs,2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Generovani nulove vystupni posloupnosti
out = zeros(slen,1);

% Hlavni cyklus
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:wnum,

  % Nastaveni indexu a vyber segmentu
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  ii=(i-1)*wstep+1;
  jj=(i-1)*wstep+wlen;

  frame=sig(ii:jj).*w;
  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % Zde bude modifikace
  X=fft(frame);
  Xabs = abs(X) ;
  Xangle = angle(X) ;
  
  % 1) Odladeni bez modifikace

  % yframe = frame ;
  
  % 2) pasmova filtrace
  
  % Y=X.*H ;
  % yframe = ifft(Y) ;
  
  % 3) spektralni odecitani
  
  Yabs = Xabs - Navg ;
  Yabs = ( Yabs + abs(Yabs) )./ 2 ;   % Jednocestne usmerneni
  %  Yabs = abs( Yabs ) ;   % Dvoucestne usmerneni

  yframe = real ( ifft( Yabs .* exp (j*Xangle) ) ) ;
  
  % Pricteni do vystupni posloupnosti (secteni presahu)
  out(ii:jj)=out(ii:jj)+yframe ;

end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Normovani vystupniho signalu
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

scale = sum ( w(1:wstep:wlen) ) ;
out = out ./ scale ;


subplot(212);
plot(out) ;
title('Vystupni signal');

figure(2)
subplot(211);
spectrogram(sig,wlen,[],[],fs,'yaxis'); 
title('Spektrogram vstupniho signalu');
subplot(212);
spectrogram(out,wlen,[],[],fs,'yaxis'); 
title('Spektrogram vystupniho signalu');
